function [a,b,c,d]=condition_C(nablax_u_k,nablay_u_k,p1_k,p2_k,alpha,X_A_gamma,nu_Xi_t)
%Modify the Matrix, [a,b;c,d], to satisfy the condition (b+c)^2<=4ad.
%ONLY OUTPUT FOUR VECTORS.
%Written by Yiqiu Dong on Sep. 18, 2008.

temp=max(nu_Xi_t,eps);
temp1=nablax_u_k./temp;
temp2=nablay_u_k./temp;


%% Calculate (a,b,c,d)
a=alpha-X_A_gamma.*p1_k.*temp1;

b=-X_A_gamma.*p1_k.*temp2;

c=-X_A_gamma.*p2_k.*temp1;

d=alpha-X_A_gamma.*p2_k.*temp2;

% cond_C=((b+c).^2/4-a.*d>0);
% v=2*sqrt(a(cond_C).*d(cond_C))./max(eps,abs(b(cond_C)+c(cond_C)));
% b(cond_C)=v.*b(cond_C);
% c(cond_C)=v.*c(cond_C);
